Index: /branches/HiveStatistics/sources/HeuristicLab.MainForm.WindowsForms/3.3/HeuristicLab.MainForm.WindowsForms-3.3.csproj
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.MainForm.WindowsForms/3.3/HeuristicLab.MainForm.WindowsForms-3.3.csproj	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.MainForm.WindowsForms/3.3/HeuristicLab.MainForm.WindowsForms-3.3.csproj	(revision 12584)
@@ -165,7 +165,5 @@
     <None Include="Plugin.cs.frame" />
     <Compile Include="Controls\ControlExtensions.cs" />
-    <Compile Include="MainForms\DockForm.cs">
-      <SubType>Form</SubType>
-    </Compile>
+    <Compile Include="MainForms\DockForm.cs" />
     <Compile Include="MainForms\DockForm.Designer.cs">
       <DependentUpon>DockForm.cs</DependentUpon>
Index: /branches/HiveStatistics/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlParser.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlParser.cs	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlParser.cs	(revision 12584)
@@ -193,6 +193,11 @@
       try {
         using (FileStream fs = new FileStream(filename, FileMode.Open, FileAccess.Read)) {
-          using (ZipArchive zip = new ZipArchive(fs)) {
-            return Deserialize(zip);
+          try {
+            using (ZipArchive zip = new ZipArchive(fs)) {
+              return Deserialize(zip);
+            }
+          }
+          catch (Exception) {
+            return DeserializeWithGZip(fs);
           }
         }
Index: /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Advanced/DeploymentService/AdminServiceClientFactory.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Advanced/DeploymentService/AdminServiceClientFactory.cs	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Advanced/DeploymentService/AdminServiceClientFactory.cs	(revision 12584)
@@ -35,5 +35,5 @@
     /// </summary>
     static AdminServiceClientFactory() {
-      var stream = Assembly.GetExecutingAssembly().GetManifestResourceStream("HeuristicLab.PluginInfrastructure.Advanced.DeploymentService.services.heuristiclab.com.cer");
+      var stream = Assembly.GetExecutingAssembly().GetManifestResourceStream("HeuristicLab.PluginInfrastructure.Advanced.DeploymentService.localhost.cer");
       serverCrtData = new byte[stream.Length];
       stream.Read(serverCrtData, 0, serverCrtData.Length);
Index: /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Advanced/DeploymentService/GenerateServiceClients.cmd
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Advanced/DeploymentService/GenerateServiceClients.cmd	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Advanced/DeploymentService/GenerateServiceClients.cmd	(revision 12584)
@@ -7,6 +7,6 @@
 
 svcutil.exe ^
-  http://services.heuristiclab.com/Deployment-3.3/UpdateService.svc/mex ^
-  http://services.heuristiclab.com/Deployment-3.3/AdminService.svc/mex ^
+  http://localhost/Deployment-3.3/UpdateService.svc/mex ^
+  http://localhost/Deployment-3.3/AdminService.svc/mex ^
   /out:ServiceClients ^
   /namespace:*,HeuristicLab.PluginInfrastructure.Advanced.DeploymentService ^
Index: /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Advanced/DeploymentService/UpdateServiceClientFactory.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Advanced/DeploymentService/UpdateServiceClientFactory.cs	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Advanced/DeploymentService/UpdateServiceClientFactory.cs	(revision 12584)
@@ -35,5 +35,5 @@
     /// </summary>
     static UpdateServiceClientFactory() {
-      var stream = Assembly.GetExecutingAssembly().GetManifestResourceStream("HeuristicLab.PluginInfrastructure.Advanced.DeploymentService.services.heuristiclab.com.cer");
+      var stream = Assembly.GetExecutingAssembly().GetManifestResourceStream("HeuristicLab.PluginInfrastructure.Advanced.DeploymentService.localhost.cer");
       serverCrtData = new byte[stream.Length];
       stream.Read(serverCrtData, 0, serverCrtData.Length);
Index: /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Properties/Settings.Designer.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Properties/Settings.Designer.cs	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Properties/Settings.Designer.cs	(revision 12584)
@@ -62,5 +62,5 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("http://services.heuristiclab.com/Deployment-3.3/UpdateService.svc")]
+        [global::System.Configuration.DefaultSettingValueAttribute("http://localhost/Deployment-3.3/UpdateService.svc")]
         public string UpdateLocation {
             get {
@@ -74,5 +74,5 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("http://services.heuristiclab.com/Deployment-3.3/AdminService.svc")]
+        [global::System.Configuration.DefaultSettingValueAttribute("http://localhost/Deployment-3.3/AdminService.svc")]
         public string UpdateLocationAdministrationAddress {
             get {
Index: /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Properties/Settings.settings
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Properties/Settings.settings	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.PluginInfrastructure/3.3/Properties/Settings.settings	(revision 12584)
@@ -13,8 +13,8 @@
     </Setting>
     <Setting Name="UpdateLocation" Type="System.String" Scope="User">
-      <Value Profile="(Default)">http://services.heuristiclab.com/Deployment-3.3/UpdateService.svc</Value>
+      <Value Profile="(Default)">http://localhost/Deployment-3.3/UpdateService.svc</Value>
     </Setting>
     <Setting Name="UpdateLocationAdministrationAddress" Type="System.String" Scope="User">
-      <Value Profile="(Default)">http://services.heuristiclab.com/Deployment-3.3/AdminService.svc</Value>
+      <Value Profile="(Default)">http://localhost/Deployment-3.3/AdminService.svc</Value>
     </Setting>
   </Settings>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Access/3.3/HeuristicLab.Services.Access-3.3.csproj
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Access/3.3/HeuristicLab.Services.Access-3.3.csproj	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Access/3.3/HeuristicLab.Services.Access-3.3.csproj	(revision 12584)
@@ -135,8 +135,12 @@
   </ItemGroup>
   <ItemGroup>
-    <None Include="App.config" />
+    <None Include="App.config">
+      <SubType>Designer</SubType>
+    </None>
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
-    <None Include="Web.config" />
+    <None Include="Web.config">
+      <SubType>Designer</SubType>
+    </None>
   </ItemGroup>
   <ItemGroup>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/AssignedResourceDao.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/AssignedResourceDao.cs	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/AssignedResourceDao.cs	(revision 12584)
@@ -22,4 +22,5 @@
 using System;
 using System.Data.Linq;
+using System.Linq;
 
 namespace HeuristicLab.Services.Hive.DataAccess.Daos {
@@ -30,4 +31,8 @@
       throw new NotImplementedException();
     }
+
+    public IQueryable<AssignedResource> GetByTaskId(Guid taskId) {
+      return Table.Where(x => x.TaskId == taskId);
+    }
   }
 }
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/JobPermissionDao.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/JobPermissionDao.cs	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/JobPermissionDao.cs	(revision 12584)
@@ -22,4 +22,5 @@
 using System;
 using System.Data.Linq;
+using System.Linq;
 
 namespace HeuristicLab.Services.Hive.DataAccess.Daos {
@@ -30,4 +31,8 @@
       throw new NotImplementedException();
     }
+
+    public JobPermission GetByJobAndUserId(Guid jobId, Guid userId) {
+      return Table.SingleOrDefault(x => x.JobId == jobId && x.GrantedUserId == userId);
+    }
   }
 }
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/StateLogDao.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/StateLogDao.cs	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/StateLogDao.cs	(revision 12584)
@@ -26,4 +26,9 @@
 namespace HeuristicLab.Services.Hive.DataAccess.Daos {
   public class StateLogDao : GenericDao<Guid, StateLog> {
+
+    private Table<Task> TaskTable {
+      get { return DataContext.GetTable<Task>(); }
+    }
+
     public StateLogDao(DataContext dataContext) : base(dataContext) { }
 
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/TaskDao.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/TaskDao.cs	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/TaskDao.cs	(revision 12584)
@@ -36,5 +36,5 @@
     }
 
-    public IQueryable<Task> GetAllByJobId(Guid id) {
+    public IQueryable<Task> GetByJobId(Guid id) {
       return Table.Where(x => x.JobId == id);
     }
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/App_Data/PublishProfiles/Hive-3.3.pubxml
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/App_Data/PublishProfiles/Hive-3.3.pubxml	(revision 12584)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/App_Data/PublishProfiles/Hive-3.3.pubxml	(revision 12584)
@@ -0,0 +1,51 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<!--
+This file is used by the publish/package process of your Web project. You can customize the behavior of this process
+by editing this MSBuild file. In order to learn more about this please visit http://go.microsoft.com/fwlink/?LinkID=208121. 
+-->
+<Project ToolsVersion="4.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <WebPublishMethod>MSDeploy</WebPublishMethod>
+    <LastUsedBuildConfiguration>Release</LastUsedBuildConfiguration>
+    <LastUsedPlatform>Any CPU</LastUsedPlatform>
+    <SiteUrlToLaunchAfterPublish />
+    <LaunchSiteAfterPublish>True</LaunchSiteAfterPublish>
+    <ExcludeApp_Data>False</ExcludeApp_Data>
+    <MSDeployServiceURL>localhost</MSDeployServiceURL>
+    <DeployIisAppPath>Default Web Site/Hive-3.3</DeployIisAppPath>
+    <RemoteSitePhysicalPath />
+    <SkipExtraFilesOnServer>True</SkipExtraFilesOnServer>
+    <MSDeployPublishMethod>InProc</MSDeployPublishMethod>
+    <EnableMSDeployBackup>False</EnableMSDeployBackup>
+    <UserName />
+    <_SavePWD>False</_SavePWD>
+    <PublishDatabaseSettings>
+      <Objects xmlns="">
+        <ObjectGroup Name="HeuristicLab.Services.Hive.DataAccess.Settings.HeuristicLab_Hive_LinqConnectionString" Order="1" Enabled="False">
+          <Destination Path="" />
+          <Object Type="DbDacFx">
+            <PreSource Path="Data Source=.\SQLEXPRESS;Initial Catalog=HeuristicLab.Hive-3.3;Integrated Security=True" includeData="False" />
+            <Source Path="$(IntermediateOutputPath)AutoScripts\HeuristicLab.Services.Hive.DataAccess.Settings.HeuristicLab_Hive_LinqConnectionString_IncrementalSchemaOnly.dacpac" dacpacAction="Deploy" />
+          </Object>
+          <UpdateFrom Type="Web.Config">
+            <Source MatchValue="Data Source=.\SQLEXPRESS;Initial Catalog=HeuristicLab.Hive-3.3;Integrated Security=True;" MatchAttributes="$(UpdateFromConnectionStringAttributes)" />
+          </UpdateFrom>
+        </ObjectGroup>
+        <ObjectGroup Name="HeuristicLab.Authentication" Order="2" Enabled="False">
+          <Destination Path="" />
+          <Object Type="DbDacFx">
+            <PreSource Path="data source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Authentication" includeData="False" />
+            <Source Path="$(IntermediateOutputPath)AutoScripts\HeuristicLab.Authentication_IncrementalSchemaOnly.dacpac" dacpacAction="Deploy" />
+          </Object>
+          <UpdateFrom Type="Web.Config">
+            <Source MatchValue="data source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Authentication" MatchAttributes="$(UpdateFromConnectionStringAttributes)" />
+          </UpdateFrom>
+        </ObjectGroup>
+      </Objects>
+    </PublishDatabaseSettings>
+  </PropertyGroup>
+  <ItemGroup>
+    <MSDeployParameterValue Include="$(DeployParameterPrefix)HeuristicLab.Authentication-Web.config Connection String" />
+    <MSDeployParameterValue Include="$(DeployParameterPrefix)HeuristicLab.Services.Hive.DataAccess.Settings.HeuristicLab_Hive_LinqConnectionString-Web.config Connection String" />
+  </ItemGroup>
+</Project>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/website.publishproj
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/website.publishproj	(revision 12584)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/website.publishproj	(revision 12584)
@@ -0,0 +1,67 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<!--
+
+***********************************************************************************************
+website.publishproj
+
+WARNING: DO NOT MODIFY this file, it is used for the web publish process.
+
+Copyright (C) Microsoft Corporation. All rights reserved.
+
+***********************************************************************************************
+-->
+<Project ToolsVersion="4.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>10.0.30319</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{7523325a-a0a3-4b85-be27-4f25187e0c0d}</ProjectGuid>
+    <SourceWebPhysicalPath>$(MSBuildThisFileDirectory)</SourceWebPhysicalPath>
+    <SourceWebVirtualPath>/Hive-3.3</SourceWebVirtualPath>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <SourceWebProject>C:\dglaser\HeuristicLab\branches\HiveStatistics\sources\HeuristicLab.Services.Hive.Web\Hive-3.3</SourceWebProject>
+    <SourceWebMetabasePath>/IISExpress/7.5/LM/W3SVC/3/ROOT</SourceWebMetabasePath>
+  </PropertyGroup>
+  <PropertyGroup>
+    <VisualStudioVersion Condition="'$(VisualStudioVersion)' == ''">10.0</VisualStudioVersion>
+    <!-- for VS2010 we need to use 10.5 but for VS2012+ we should use VisualStudioVersion -->
+    <WebPublishTargetsVersion Condition=" '$(WebPublishTargetsVersion)' =='' and '$(VisualStudioVersion)' == 10.0 ">10.5</WebPublishTargetsVersion>
+    <WebPublishTargetsVersion Condition=" '$(WebPublishTargetsVersion)'=='' ">$(VisualStudioVersion)</WebPublishTargetsVersion>
+    <VSToolsPath Condition="'$(VSToolsPath)' == ''">$(MSBuildExtensionsPath32)\Microsoft\VisualStudio\v$(WebPublishTargetsVersion)</VSToolsPath>
+    <_WebPublishTargetsPath Condition=" '$(_WebPublishTargetsPath)'=='' ">$(VSToolsPath)</_WebPublishTargetsPath>
+    <AssemblyFileVersion Condition="'$(AssemblyFileVersion)' == ''">1.0.0.0</AssemblyFileVersion>
+    <AssemblyVersion Condition="'$(AssemblyVersion)' == ''">1.0.0.0</AssemblyVersion>
+  </PropertyGroup>
+  <ItemGroup>
+    <AssemblyAttributes Include="AssemblyFileVersion">
+      <Value>$(AssemblyFileVersion)</Value>
+    </AssemblyAttributes>
+    <AssemblyAttributes Include="AssemblyVersion">
+      <Value>$(AssemblyVersion)</Value>
+    </AssemblyAttributes>
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.ExtLibs\HeuristicLab.GeoIP\1.12\HeuristicLab.GeoIP.csproj">
+      <Project>{BE9B0229-9150-49A4-AEA6-BB58E055992F}</Project>
+      <Name>HeuristicLab.GeoIP</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Services.Access.DataAccess\3.3\HeuristicLab.Services.Access.DataAccess-3.3.csproj">
+      <Project>{0F652437-998A-4EAB-8BF1-444B5FE8CE97}</Project>
+      <Name>HeuristicLab.Services.Access.DataAccess-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Services.Access\3.3\HeuristicLab.Services.Access-3.3.csproj">
+      <Project>{9FAC0B23-2730-452A-9BA0-D7CA1746C541}</Project>
+      <Name>HeuristicLab.Services.Access-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Services.Hive.DataAccess\3.3\HeuristicLab.Services.Hive.DataAccess-3.3.csproj">
+      <Project>{EC2C8109-6E1E-4C88-9A2B-908CFF2EF4AC}</Project>
+      <Name>HeuristicLab.Services.Hive.DataAccess-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Services.Hive\3.3\HeuristicLab.Services.Hive-3.3.csproj">
+      <Project>{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}</Project>
+      <Name>HeuristicLab.Services.Hive-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <Import Project="$(_WebPublishTargetsPath)\Web\Microsoft.WebSite.Publishing.targets" />
+</Project>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Convert.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Convert.cs	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Convert.cs	(revision 12584)
@@ -22,5 +22,4 @@
 using System;
 using System.Collections.Generic;
-using System.Data.Linq;
 using System.Linq;
 using DB = HeuristicLab.Services.Hive.DataAccess;
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Converter.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Converter.cs	(revision 12584)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Converter.cs	(revision 12584)
@@ -0,0 +1,255 @@
+﻿using System;
+using System.Linq;
+using DA = HeuristicLab.Services.Hive.DataAccess;
+using DT = HeuristicLab.Services.Hive.DataTransfer;
+
+namespace HeuristicLab.Services.Hive {
+  public static class Converter {
+
+    #region Task
+    public static DT.Task ToDto(this DA.Task source) {
+      if (source == null) return null;
+      return new DT.Task {
+        Id = source.TaskId,
+        State = source.State.ToDto(),
+        ExecutionTime = TimeSpan.FromMilliseconds(source.ExecutionTimeMs),
+        LastHeartbeat = source.LastHeartbeat,
+        ParentTaskId = source.ParentTaskId,
+        Priority = source.Priority,
+        CoresNeeded = source.CoresNeeded,
+        MemoryNeeded = source.MemoryNeeded,
+        IsParentTask = source.IsParentTask,
+        FinishWhenChildJobsFinished = source.FinishWhenChildJobsFinished,
+        Command = source.Command.ToDto(),
+        JobId = source.JobId,
+        IsPrivileged = source.IsPrivileged,
+        PluginsNeededIds = source.RequiredPlugins.Select(x => x.PluginId).ToList(),
+        StateLog = source.StateLogs.Select(x => x.ToDto()).OrderBy(x => x.DateTime).ToList(),
+        LastTaskDataUpdate = source.JobData == null ? DateTime.MinValue : source.JobData.LastUpdate
+      };
+    }
+
+    public static DA.Task ToEntity(this DT.Task source) {
+      if (source == null) return null;
+      var result = new DA.Task();
+      source.CopyToEntity(result);
+      return result;
+    }
+
+    public static void CopyToEntity(this DT.Task source, DA.Task target) {
+      if ((source == null) || (target == null)) return;
+      target.TaskId = source.Id;
+      target.State = source.State.ToEntity();
+      target.ExecutionTimeMs = source.ExecutionTime.TotalMilliseconds;
+      target.LastHeartbeat = source.LastHeartbeat;
+      target.ParentTaskId = source.ParentTaskId;
+      target.Priority = source.Priority;
+      target.CoresNeeded = source.CoresNeeded;
+      target.MemoryNeeded = source.MemoryNeeded;
+      target.IsParentTask = source.IsParentTask;
+      target.FinishWhenChildJobsFinished = source.FinishWhenChildJobsFinished;
+      target.Command = source.Command.ToEntity();
+      target.JobId = source.JobId;
+      target.IsPrivileged = source.IsPrivileged;
+      var ids = target.RequiredPlugins.Select(x => x.PluginId);
+      target.RequiredPlugins.AddRange(source.PluginsNeededIds
+        .Where(x => !ids.Contains(x))
+        .Select(x => new DA.RequiredPlugin {
+          PluginId = x
+        })
+      );
+      target.StateLogs.AddRange(source.StateLog
+        .Where(x => x.Id == Guid.Empty)
+        .Select(x => x.ToEntity())
+      );
+      // result.JobData missing
+      // result.AssignedResources missing
+    }
+    #endregion
+
+    #region TaskData
+    public static DT.TaskData ToDto(this DA.TaskData source) {
+      if (source == null) return null;
+      return new DT.TaskData {
+        TaskId = source.TaskId,
+        Data = source.Data,
+        LastUpdate = source.LastUpdate
+      };
+    }
+
+    public static DA.TaskData ToEntity(this DT.TaskData source) {
+      if (source == null) return null;
+      var result = new DA.TaskData();
+      source.CopyToEntity(result);
+      return result;
+    }
+
+    public static void CopyToEntity(this DT.TaskData source, DA.TaskData target) {
+      if ((source == null) || (target == null)) return;
+      target.TaskId = source.TaskId;
+      target.Data = source.Data;
+      target.LastUpdate = source.LastUpdate;
+    }
+    #endregion
+
+    #region Job
+    public static DT.Job ToDto(this DA.Job source) {
+      return new DT.Job {
+        Id = source.JobId,
+        Description = source.Description,
+        Name = source.Name,
+        OwnerUserId = source.OwnerUserId,
+        DateCreated = source.DateCreated,
+        ResourceNames = source.ResourceIds
+      };
+    }
+
+    public static DA.Job ToEntity(this DT.Job source) {
+      if (source == null) return null;
+      var result = new DA.Job();
+      source.CopyToEntity(result);
+      return result;
+    }
+
+    public static void CopyToEntity(this DT.Job source, DA.Job target) {
+      if ((source == null) || (target == null)) return;
+      target.JobId = source.Id;
+      target.Description = source.Description;
+      target.Name = source.Name;
+      target.OwnerUserId = source.OwnerUserId;
+      target.DateCreated = source.DateCreated;
+      target.ResourceIds = source.ResourceNames;
+    }
+    #endregion
+
+    #region JobPermission
+    public static DT.JobPermission ToDto(this DA.JobPermission source) {
+      if (source == null) return null;
+      return new DT.JobPermission {
+        JobId = source.JobId,
+        GrantedUserId = source.GrantedUserId,
+        GrantedByUserId = source.GrantedByUserId,
+        Permission = source.Permission.ToDto()
+      };
+    }
+
+    public static DA.JobPermission ToEntity(this DT.JobPermission source) {
+      if (source == null) return null;
+      var result = new DA.JobPermission();
+      source.CopyToEntity(result);
+      return result;
+    }
+
+    public static void CopyToEntity(this DT.JobPermission source, DA.JobPermission target) {
+      if ((source == null) || (target == null)) return;
+      target.JobId = source.JobId;
+      target.GrantedUserId = source.GrantedUserId;
+      target.GrantedByUserId = source.GrantedByUserId;
+      target.Permission = source.Permission.ToEntity();
+    }
+    #endregion
+
+    #region State
+    public static DT.TaskState ToDto(this DA.TaskState source) {
+      switch (source) {
+        case DA.TaskState.Aborted: return DT.TaskState.Aborted;
+        case DA.TaskState.Calculating: return DT.TaskState.Calculating;
+        case DA.TaskState.Failed: return DT.TaskState.Failed;
+        case DA.TaskState.Finished: return DT.TaskState.Finished;
+        case DA.TaskState.Offline: return DT.TaskState.Offline;
+        case DA.TaskState.Paused: return DT.TaskState.Paused;
+        case DA.TaskState.Transferring: return DT.TaskState.Transferring;
+        case DA.TaskState.Waiting: return DT.TaskState.Waiting;
+        default: return DT.TaskState.Failed;
+      }
+    }
+
+    public static DA.TaskState ToEntity(this DT.TaskState source) {
+      switch (source) {
+        case DT.TaskState.Aborted: return DA.TaskState.Aborted;
+        case DT.TaskState.Calculating: return DA.TaskState.Calculating;
+        case DT.TaskState.Failed: return DA.TaskState.Failed;
+        case DT.TaskState.Finished: return DA.TaskState.Finished;
+        case DT.TaskState.Offline: return DA.TaskState.Offline;
+        case DT.TaskState.Paused: return DA.TaskState.Paused;
+        case DT.TaskState.Transferring: return DA.TaskState.Transferring;
+        case DT.TaskState.Waiting: return DA.TaskState.Waiting;
+        default: return DA.TaskState.Failed;
+      }
+    }
+    #endregion
+
+    #region StateLogs
+    public static DT.StateLog ToDto(this DA.StateLog source) {
+      return new DT.StateLog {
+        Id = source.StateLogId,
+        State = source.State.ToDto(),
+        DateTime = source.DateTime,
+        TaskId = source.TaskId,
+        UserId = source.UserId,
+        SlaveId = source.SlaveId,
+        Exception = source.Exception
+      };
+    }
+
+    public static DA.StateLog ToEntity(this DT.StateLog source) {
+      return new DA.StateLog {
+        StateLogId = source.Id,
+        State = source.State.ToEntity(),
+        DateTime = source.DateTime,
+        TaskId = source.TaskId,
+        UserId = source.UserId,
+        SlaveId = source.SlaveId,
+        Exception = source.Exception
+      };
+    }
+    #endregion
+
+    #region Command
+    public static DT.Command? ToDto(this DA.Command? source) {
+      if (source.HasValue) {
+        switch (source) {
+          case DA.Command.Abort: return DT.Command.Abort;
+          case DA.Command.Pause: return DT.Command.Pause;
+          case DA.Command.Stop: return DT.Command.Stop;
+          default: return DT.Command.Pause;
+        }
+      }
+      return null;
+    }
+
+    public static DA.Command? ToEntity(this DT.Command? source) {
+      if (source.HasValue) {
+        switch (source) {
+          case DT.Command.Abort: return DA.Command.Abort;
+          case DT.Command.Pause: return DA.Command.Pause;
+          case DT.Command.Stop: return DA.Command.Stop;
+          default: return DA.Command.Pause;
+        }
+      }
+      return null;
+    }
+    #endregion
+
+    #region Permission
+    public static DT.Permission ToDto(this DA.Permission source) {
+      switch (source) {
+        case DA.Permission.Full: return DT.Permission.Full;
+        case DA.Permission.NotAllowed: return DT.Permission.NotAllowed;
+        case DA.Permission.Read: return DT.Permission.Read;
+        default: return DT.Permission.NotAllowed;
+      }
+    }
+
+    public static DA.Permission ToEntity(this DT.Permission source) {
+      switch (source) {
+        case DT.Permission.Full: return DA.Permission.Full;
+        case DT.Permission.NotAllowed: return DA.Permission.NotAllowed;
+        case DT.Permission.Read: return DA.Permission.Read;
+        default: return DA.Permission.NotAllowed;
+      }
+    }
+    #endregion
+
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HeuristicLab.Services.Hive-3.3.csproj
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HeuristicLab.Services.Hive-3.3.csproj	(revision 12583)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HeuristicLab.Services.Hive-3.3.csproj	(revision 12584)
@@ -119,4 +119,5 @@
   <ItemGroup>
     <Compile Include="Convert.cs" />
+    <Compile Include="Converter.cs" />
     <Compile Include="DataTransfer\Command.cs" />
     <Compile Include="DataTransfer\UserPriority.cs" />
@@ -145,4 +146,5 @@
     <Compile Include="HiveStatisticsGenerator.cs" />
     <Compile Include="Interfaces\IStatisticsGenerator.cs" />
+    <Compile Include="NewHiveService.cs" />
     <Compile Include="OptimizedHiveDao.cs" />
     <Compile Include="HiveDao.cs" />
